#import <Foundation/Foundation.h>
#import "Bull.h"
#import "Cattle.h"
#import "MyNSObject.h"

int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
	Bull *redBull = [[Bull alloc] initWithLegsCount:4 
											 gender:YES 
										  eyesCount:2 
										 masterName:@"that cowboy"];
	[redBull setSkinColor:@"red"];
	[redBull saySomething];
	
	//legal, but not good
	redBull->masterName = @"that cowgirl";
	//legal, but bad
	//redBull->eyesCount = 3;
	
	//Trying to access a private ivar, VERY bad thing
	//MyClass bullClass = redBull->isa;
	bool *redBullGender = (bool *)(redBull) + 8;
	NSLog(@"My gender is %@",*redBullGender ? @"male" : @"female");
	
    [pool drain];
    return 0;
}
